--
-- ATENCION:
--
-- Esta serie de inserciones de datos en la base de datos presupone que la base de datos est vaca
-- y que las secuencias utilizadas para crear los identificadores automticos de las distintas tablas
-- estn recin creados y todava no han sido usados.
-- De lo contrario, los valores de las claves forneas utilizados no relacionarn las filas de las 
-- distintas tablas de la manera esperada.
--
INSERT INTO Pais (nombre) VALUES ('Francia');
INSERT INTO Pais (nombre) VALUES ('Espaa');
INSERT INTO Pais (nombre) VALUES ('Alemania');
-- 
INSERT INTO Region (nombre, idPais) VALUES ('Alsacia', 1);
INSERT INTO Region (nombre, idPais) VALUES ('Madrid', 2);
INSERT INTO Region (nombre, idPais) VALUES ('Catalunya', 2);
INSERT INTO Region (nombre, idPais) VALUES ('Illes Balears', 2);
--
INSERT INTO Ciudad (nombre, idRegion) VALUES ('Estrasburgo', 1);
INSERT INTO Ciudad (nombre, idRegion) VALUES ('Madrid', 2);
INSERT INTO Ciudad (nombre, idRegion) VALUES ('Barcelona', 3);
INSERT INTO Ciudad (nombre, idRegion) VALUES ('Palma de Mallorca', 4);
--
INSERT INTO TipoParlamento (descripcion) VALUES ('Parlamento europeo');
INSERT INTO TipoParlamento (descripcion) VALUES ('Parlamento nacional');
INSERT INTO TipoParlamento (descripcion) VALUES ('Parlamento regional');
--
INSERT INTO Partido (nombre) VALUES ('PSOE');
INSERT INTO Partido (nombre) VALUES ('PP');
INSERT INTO Partido (nombre) VALUES ('UPyD');
INSERT INTO Partido (nombre) VALUES ('CiU');
INSERT INTO Partido (nombre) VALUES ('PNV');
INSERT INTO Partido (nombre) VALUES ('IU');
INSERT INTO Partido (nombre) VALUES ('GRUPO MIXTO');
--
INSERT INTO FormaPago (descripcion) VALUES ('Pagado mediante transferencia bancaria');
INSERT INTO FormaPago (descripcion) VALUES ('Pagado mediante tarjeta de crdito');
--
INSERT INTO Estado (descripcion, FormaPagoSN) VALUES ('Pendiente aprobacin. No pagado.', 'F');
INSERT INTO Estado (descripcion, FormaPagoSN) VALUES ('Pendiente aprobacin. Pagado.', 'T');			
INSERT INTO Estado (descripcion, FormaPagoSN) VALUES ('Aprobado. No pagado.', 'F');
INSERT INTO Estado (descripcion, FormaPagoSN) VALUES ('Aprobado. Pagado.', 'T');
INSERT INTO Estado (descripcion, FormaPagoSN) VALUES ('Rechazado. No Pagado.', 'F');						
INSERT INTO Estado (descripcion, FormaPagoSN) VALUES ('Rechazado. Pagado. Importe a devolver.', 'T');						
--
INSERT INTO Ejercicio (idEjercicio, inicio, fin, cerradoSN) VALUES (2010, TO_DATE('01-01-2010', 'DD-MM-YYYY'), TO_DATE('31-12-2010', 'DD-MM-YYYY'), 'T');
INSERT INTO Ejercicio (idEjercicio, inicio, fin, cerradoSN) VALUES (2011, TO_DATE('01-01-2011', 'DD-MM-YYYY'), TO_DATE('31-12-2011', 'DD-MM-YYYY'), 'T');
INSERT INTO Ejercicio (idEjercicio, inicio, fin, cerradoSN) VALUES (2012, TO_DATE('01-01-2012', 'DD-MM-YYYY'), TO_DATE('31-12-2012', 'DD-MM-YYYY'), 'T');
INSERT INTO Ejercicio (idEjercicio, inicio, fin, cerradoSN) VALUES (2013, TO_DATE('01-01-2013', 'DD-MM-YYYY'), TO_DATE('31-12-2013', 'DD-MM-YYYY'), 'F');
INSERT INTO Ejercicio (idEjercicio, inicio, fin, cerradoSN) VALUES (2014, TO_DATE('01-01-2014', 'DD-MM-YYYY'), TO_DATE('31-12-2014', 'DD-MM-YYYY'), 'F');
--
INSERT INTO Proveedor (nombre, CIF) VALUES ('PARLAMENTO EUROPEO',            'EU000000000');
INSERT INTO Proveedor (nombre, CIF) VALUES ('CONGRESO DE LOS DIPUTADOS',     'ES000000000');
INSERT INTO Proveedor (nombre, CIF) VALUES ('AEROLINEAS DE PARLAMENTOS SA',  'ES222222222');
INSERT INTO Proveedor (nombre, CIF) VALUES ('TELEFONICA DE PARLAMENTOS SA',  'ES111111111');
INSERT INTO Proveedor (nombre, CIF) VALUES ('INFORMATICA DE PARLAMENTOS SA', 'ES333333333');
--
INSERT INTO TipoIVA (porcentajeIVA) VALUES (0.00);
INSERT INTO TipoIVA (porcentajeIVA) VALUES (10.00);
--
INSERT INTO TipoGasto (descripcion, parlamentarioSN) VALUES ('Sueldos parlamentarios', 'T');
INSERT INTO TipoGasto (descripcion, parlamentarioSN) VALUES ('Sueldos empleados parlamento', 'F');
INSERT INTO TipoGasto (descripcion, parlamentarioSN) VALUES ('Transportes parlamentarios', 'T');
INSERT INTO TipoGasto (descripcion, parlamentarioSN) VALUES ('Transportes parlamento', 'F');
INSERT INTO TipoGasto (descripcion, parlamentarioSN) VALUES ('Comunicaciones parlamentarios', 'T');
INSERT INTO TipoGasto (descripcion, parlamentarioSN) VALUES ('Comunicaciones parlamento', 'F');
INSERT INTO TipoGasto (descripcion, parlamentarioSN) VALUES ('Informtica parlamentarios', 'T');
INSERT INTO TipoGasto (descripcion, parlamentarioSN) VALUES ('Informtica parlamento', 'F');
--
INSERT INTO CategoriaGasto (descripcion, idTipoGasto) VALUES ('Nminas parlamentarios', 1);
INSERT INTO CategoriaGasto (descripcion, idTipoGasto) VALUES ('Billetes avin parlamentarios', 3);
INSERT INTO CategoriaGasto (descripcion, idTipoGasto) VALUES ('Telfonos parlamentarios', 5);
INSERT INTO CategoriaGasto (descripcion, idTipoGasto) VALUES ('Ordenadores parlamentarios', 7);
INSERT INTO CategoriaGasto (descripcion, idTipoGasto) VALUES ('Nminas trabajadores parlamento', 2);
INSERT INTO CategoriaGasto (descripcion, idTipoGasto) VALUES ('Billetes avin parlamento', 4);
INSERT INTO CategoriaGasto (descripcion, idTipoGasto) VALUES ('Telfonos parlamento', 6);
INSERT INTO CategoriaGasto (descripcion, idTipoGasto) VALUES ('Ordenadores parlamento', 8);
--
COMMIT;
