SET SERVEROUTPUT ON;
-- Consultamos el contenido relevante de la tabla Gasto ordenado por idGasto
SELECT
  idGasto,
  fecha,
  idEjercicio,
  idParlamento,
  idParlamentario,
  idPartido,
  baseImponible,
  idTipoIVA,
  idCategoriaGasto,
  idEstado,
  idFormaPago,
  idProveedor
FROM
  Gasto
ORDER BY idGasto;

-- Consultamos el contenido relevante de la tabla Gasto ordenado por idEjercicio, idParlamento, idParlamentario
SELECT
  idGasto,
  fecha,
  idEjercicio,
  idParlamento,
  idParlamentario,
  idPartido,
  baseImponible,
  idTipoIVA,
  idCategoriaGasto,
  idEstado,
  idFormaPago,
  idProveedor
FROM
  Gasto
ORDER BY idEjercicio, idParlamento, idParlamentario;

-- Consultamos en tabla Gasto los gastos imputables a parlamentarios totalizando por idEjercicio, idParlamento, idParlamentario ordenado por idEjercicio, idParlamento, idParlamentario
SELECT
  idEjercicio,
  idParlamento,
  idParlamentario,
  SUM (baseImponible)
FROM
  Gasto
WHERE
  idParlamentario IS NOT NULL
GROUP BY idEjercicio, idParlamento, idParlamentario
ORDER BY idEjercicio, idParlamento, idParlamentario;

-- Consultamos el contenido de la tabla de estadsticas ParlamentarioST ordenado por idEjercicio, idParlamento, idParlamentario
SELECT *
FROM
  ParlamentarioST
ORDER BY idEjercicio, idParlamento, idParlamentario;

-- Consultamos la tabla Gasto los gastos imputables a parlamentos totalizando por idEjercicio, idParlamento ordenado por idEjercicio, idParlamento
SELECT
  idEjercicio,
  idParlamento,
  SUM (baseImponible)
FROM
  Gasto
WHERE
  idParlamentario IS NULL
GROUP BY idEjercicio, idParlamento
ORDER BY idEjercicio, idParlamento;

-- Consultamos el contenido de la tabla de estadsticas ParlamentarioST totalizando por idEjercicio, idParlamento y ordenado por idEjercicio, idParlamento
SELECT
  idEjercicio,
  idParlamento,
  SUM (totalgastos)
FROM
  ParlamentarioST
GROUP BY idEjercicio, idParlamento
ORDER BY idEjercicio, idParlamento;

-- Consultamos el contenido de la tabla de estadsticas ParlamentoST ordenado por idEjercicio, idParlamento
SELECT *
FROM
  ParlamentoST
ORDER BY idEjercicio, idParlamento;