DECLARE
  --
  rsp               Registro.salida % TYPE;
  idParlamento      Parlamento.idParlamento % TYPE;
  idParlamentario   Parlamentario.idParlamentario % TYPE;
  idPartido         Partido.idPartido % TYPE;
  numParlamentarios Parlamento.maxParlamentarios % TYPE;
  fecha             ParlamentoDH.desde % TYPE;
--
BEGIN
  --
  DBMS_OUTPUT.ENABLE (buffer_size => NULL);
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('RESULTADOS TEST EXCEPCIONES ABM PARLAMENTO Y PARLAMENTARIO');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('SE PROVOCAN EXCEPCIONES...');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('BAJA Parlamento');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idParlamento := 222;		  -- No existe
  pkg_parlamento.baja (idParlamento, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('MODIFICACION Parlamento');
  DBMS_OUTPUT.NEW_LINE;
  --
  --	
  idParlamento := 222;		  -- No existe
  pkg_parlamento.modificacion (idParlamento, 'Parlamento Europeo', 1, 1, '1, Avenue du Prsident Robert Schuman', 'F-67070', '+33 3 88 17 40 01', 'http://www.europarl.europa.eu/', 736, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamento := 2;
  numParlamentarios := 3;		-- Este parlamento ya tiene un nmero mayor de parlamentarios
  pkg_parlamento.modificacion (idParlamento, 'Congreso de los Diputados', 2, 2, 'Floridablanca s/n', '28071', '+34 91 390 60 00', 'http://www.congreso.es/', numParlamentarios, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('BAJA Parlamentario');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idParlamentario := 75;		-- No existe
  pkg_parlamentario.baja (idParlamentario, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('MODIFICACION Parlamentario');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idParlamentario := 75;		-- No existe
  pkg_parlamentario.modificacion (idParlamentario, 'Jose Luis', 'Rodrguez Zapatero', rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('MODIFICACION PartidoDH');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idParlamentario := 75;		-- No existe
  idPartido := 2;
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.partido_hasta (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;
  idPartido := 222;			    -- No existe
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.partido_hasta (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 11;		-- No est en ningn partido
  idPartido := 2;
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.partido_hasta (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --	
  idParlamentario := 1;
  idPartido := 1;				    -- Actualmente est en el partido 2
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.partido_hasta (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --		
  idParlamentario := 1;
  idPartido := 2;
  fecha := TO_DATE ('01/01/1999', 'dd/mm/yyyy');		    -- La fecha de inicio es posterior a la fecha de fin
  pkg_parlamentario.partido_hasta (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;
  idPartido := 2;
  fecha := TO_DATE ('01/02/2013', 'dd/mm/yyyy');		    -- Hay gastos imputados con fecha posterior
  pkg_parlamentario.partido_hasta (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('MODIFICACION ParlamentoDH');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idParlamentario := 75;		-- No existe
  idParlamento := 2;
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.parlamento_hasta (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;
  idParlamento := 222;		  -- No existe
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.parlamento_hasta (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --	
  idParlamentario := 11;		-- No est en ningn parlamento
  idParlamento := 2;
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.parlamento_hasta (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --	
  idParlamentario := 1;
  idParlamento := 1;			  -- Actualmente est en el parlamento 2 
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.parlamento_hasta (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --	
  idParlamentario := 1;
  idParlamento := 2;
  fecha := TO_DATE ('01/01/1999', 'dd/mm/yyyy');		    -- La fecha de inicio es posterior a la fecha de fin
  pkg_parlamentario.parlamento_hasta (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --	
  idParlamentario := 1;
  idParlamento := 2;
  fecha := TO_DATE ('01/02/2013', 'dd/mm/yyyy');		    -- Hay gastos imputados con fecha posterior
  pkg_parlamentario.parlamento_hasta (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('ALTA PartidoDH');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idParlamentario := 1;
  idPartido := 222;			                                      -- No existe
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.partido_desde (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 100;                                     -- No existe
  idPartido := 2;
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.partido_desde (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;                                       -- Ya est en un partido
  idPartido := 2;
  fecha := TO_DATE ('01/01/2000', 'dd/mm/yyyy');
  pkg_parlamentario.partido_desde (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 10;
  idPartido := 1;
  fecha := TO_DATE ('01/02/2013', 'dd/mm/yyyy');
  -- El parlamentario 10 abandona el partido 1 en fecha 01/02/2013 pero sigue en el parlamento 1 sin haber sido
  -- asignado a ningn otro partido  
  pkg_parlamentario.partido_hasta (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  -- Se intenta dar de alta el parlamentario 10 en el partido 2 en fecha 31/01/2013
  idParlamentario := 10;
  idParlamento := 2;
  fecha := TO_DATE ('31/01/2013', 'dd/mm/yyyy');            -- Inicio no puede ser anterior a 01/02/2013
  pkg_parlamentario.partido_desde (idParlamentario, idPartido, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('ALTA ParlamentoDH');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idParlamentario := 1;
  idParlamento := 222;                                        -- No existe 
  fecha := TO_DATE ('01/01/2013', 'dd/mm/yyyy');
  pkg_parlamentario.parlamento_desde (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 100;                                     -- No existe
  idParlamento := 2;
  fecha := TO_DATE ('01/01/2013', 'dd/mm/yyyy');
  pkg_parlamentario.parlamento_desde (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;                                       -- Ya est en un parlamento
  idParlamento := 2;
  fecha := TO_DATE ('01/01/2013', 'dd/mm/yyyy');
  pkg_parlamentario.parlamento_desde (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 9;
  idParlamento := 1;
  fecha := TO_DATE ('01/02/2013', 'dd/mm/yyyy');
  -- El parlamentario 9 abandona el parlamento 1 en fecha 01/02/2013
  pkg_parlamentario.parlamento_hasta (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  -- Se intenta dar de alta el parlamentario 9 en el parlamento 2 en fecha 31/01/2013
  idParlamentario := 9;
  idParlamento := 2;
  fecha := TO_DATE ('31/01/2013', 'dd/mm/yyyy');            -- Inicio no puede ser anterior a 01/02/2013
  pkg_parlamentario.parlamento_desde (idParlamentario, idParlamento, fecha, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
--
--
END;
/