DECLARE
  --
  rsp              Registro.salida % TYPE;
  idGasto          Gasto.idGasto % TYPE;
  fecha            Gasto.fecha % TYPE;
  idEjercicio      Gasto.idEjercicio % TYPE;
  idParlamento     Gasto.idParlamento % TYPE;
  idParlamentario  Gasto.idParlamentario % TYPE;
  baseImponible    Gasto.baseImponible % TYPE;
  idTipoIVA        Gasto.idTipoIVA % TYPE;
  idCategoriaGasto Gasto.idCategoriaGasto % TYPE;
  idEstado         Gasto.idEstado % TYPE;
  idFormaPago      Gasto.idFormaPago % TYPE;
  idProveedor      Gasto.idProveedor % TYPE;
  idPartido        Gasto.idPartido % TYPE;
--
BEGIN
  --
  DBMS_OUTPUT.ENABLE (buffer_size => NULL);
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('RESULTADOS TEST EXCEPCIONES ABM GASTO');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('SE PROVOCAN EXCEPCIONES...');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('ALTA Gasto');
  DBMS_OUTPUT.NEW_LINE;
  --
  fecha := NULL;                                        -- La fecha no puede ser NULL
  idParlamento := 2;
  idParlamentario := 1;
  baseImponible := 100.00;
  idTipoIVA := 1;
  idCategoriaGasto := 1;
  idEstado := 1;
  idFormaPago := NULL;
  idProveedor := 1;
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  fecha := TO_DATE ('01/01/2012', 'dd/mm/yyyy');      -- El ejercicio 2012 est cerrado
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  fecha := TO_DATE ('01/01/1999', 'dd/mm/yyyy');      -- La fecha no pertenece a ningn ejercicio de la base de datos
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  fecha := TO_DATE ('01/01/2014', 'dd/mm/yyyy');      -- Corregimos la fecha para que no provoque error
  idParlamentario := NULL;
  idCategoriaGasto := 1;                                -- Si la CategoriaGasto = 1 entonces idParlamentario no puede ser NULL
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;
  idCategoriaGasto := 5;                                -- Si la CategoriaGasto = 1 entonces idParlamentario debe ser NULL
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;
  idCategoriaGasto := 1;                                -- Corregimos categora de gasto para que no provoque error
  baseImponible := NULL;                                -- La base imponible del gasto no puede ser NULL
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  baseImponible := -1000.00;                            -- La base imponible del gasto no puede ser negativa
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  baseImponible := 1000.00;                             -- Corregimos la base imponible para que no provoque error
  idProveedor := NULL;                                  -- Si el importe supera los 30,00 Euros el proveedor no puede ser NULL
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idProveedor := 1;                                     -- Corregimos el proveedor para que no provoque error
  idEstado := 4;                                        -- Si el estado = 4 entonces la forma de pago no puede ser NULL
  idFormaPago := NULL;
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idEstado := 1;                                        -- Si el estado = 1 entonces la forma de pago debe ser NULL
  idFormaPago := 1;
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idFormaPago := NULL;                                  -- Corregimos la forma de pago para que no provoque error
  idParlamento := 222;                                  -- No existe
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamento := 2;                                    -- Corregimos el parlamento para que no provoque error
  idCategoriaGasto := 100;                              -- No existe
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idCategoriaGasto := 1;                                -- Corregimos la categora de gasto para que no provoque error
  idParlamentario := 75;                                -- No existe
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;                                 -- Corregimos el parlamentario para que no provoque error
  idProveedor := 10;                                    -- No existe
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idProveedor := 1;                                     -- Corregimos el proveedor para que no provoque error
  idTipoIVA := 10;                                      -- No existe
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idTipoIVA := 1;                                       -- Corregimos el tipo de IVA para que no provoque error
  idEstado := 10;                                       -- No existe
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idEstado := 2;                                        -- Corregimos el estado para que no provoque error
  idFormaPago := 10;                                    -- No existe
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idEstado := 1;                                        -- Corregimos el estado para que no provoque error
  idFormaPago := NULL;                                  -- Corregimos la forma de pago para que no provoque error
  idParlamentario := 10;
  idParlamento := 1;
  -- El parlamentario 10 abandon el partido 1 en fecha 01/02/2013 pero sigue en el parlamento 1 sin haber sido
  -- asignado a ningn otro partido cuando se le intentar imputar un gasto
  fecha := TO_DATE ('01/03/2014', 'dd/mm/yyyy');      -- El parlamentario no tiene partido
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 9;
  idParlamento := 1;
  -- El parlamentario 9 abandon el parlamento 1 en fecha 01/02/2013 pero se le intentar imputar un gasto
  fecha := TO_DATE ('01/03/2014', 'dd/mm/yyyy');      -- El parlamentario no est en ningn parlamento
  pkg_gasto.alta (fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('BAJA Gasto');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idGasto := 1000;                                      -- No existe
  pkg_gasto.baja (idGasto, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idGasto := 79;                                        -- El gasto est pagado y no se puede dar de baja
  pkg_gasto.baja (idGasto, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idEjercicio := 1999;                                  -- No existe
  pkg_gasto.cerrar_ejercicio (idEjercicio, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idEjercicio := 2013;                                  -- Cerramos el ejercicio 2013
  pkg_gasto.cerrar_ejercicio (idEjercicio, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idGasto := 33;                                        -- El gasto pertenece al ejercicio 2013 que est cerrado
  pkg_gasto.baja (idGasto, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  --
  DBMS_OUTPUT.NEW_LINE;
  DBMS_OUTPUT.PUT_LINE ('MODIFICACION Gasto');
  DBMS_OUTPUT.NEW_LINE;
  --
  --
  idGasto := 1000;                                      -- No existe
  fecha := TO_DATE ('01/01/2014', 'dd/mm/yyyy');
  idParlamento := 2;
  idParlamentario := 1;
  baseImponible := 100.00;
  idTipoIVA := 1;
  idCategoriaGasto := 1;
  idEstado := 1;
  idFormaPago := NULL;
  idProveedor := 1;
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idGasto := 1;                                         -- No puede eliminarse porque est pagado 
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idGasto := 33;                                        -- El gasto pertenece al ejercicio 2013 que est cerrado
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idGasto := 53;                                        -- Corregimos el idGasto para que no provoque error
  fecha := NULL;                                        -- La fecha no puede ser NULL
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  fecha := TO_DATE ('01/01/2012', 'dd/mm/yyyy');      -- El ejercicio 2012 est cerrado
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  fecha := TO_DATE ('01/01/1999', 'dd/mm/yyyy');      -- La fecha no pertenece a ningn ejercicio de la base de datos
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  fecha := TO_DATE ('01/01/2014', 'dd/mm/yyyy');      -- Corregimos la fecha para que no provoque error
  idParlamentario := NULL;
  idCategoriaGasto := 1;                                -- Si la CategoriaGasto = 1 entonces idParlamentario no puede ser NULL
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;
  idCategoriaGasto := 5;                                -- Si la CategoriaGasto = 1 entonces idParlamentario debe ser NULL
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;
  idCategoriaGasto := 1;                                -- Corregimos categora de gasto para que no provoque error
  baseImponible := NULL;                                -- La base imponible del gasto no puede ser NULL
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  baseImponible := -1000.00;                            -- La base imponible del gasto no puede ser negativa
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  baseImponible := 1000.00;                             -- Corregimos la base imponible para que no provoque error
  idProveedor := NULL;                                  -- Si el importe supera los 30,00 Euros el proveedor no puede ser NULL
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idProveedor := 1;                                     -- Corregimos el proveedor para que no provoque error
  idEstado := 4;                                        -- Si el estado = 4 entonces la forma de pago no puede ser NULL
  idFormaPago := NULL;
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idEstado := 1;                                        -- Si el estado = 1 entonces la forma de pago debe ser NULL
  idFormaPago := 1;
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idFormaPago := NULL;                                  -- Corregimos la forma de pago para que no provoque error
  idParlamento := 222;                                  -- No existe
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamento := 2;                                    -- Corregimos el parlamento para que no provoque error
  idCategoriaGasto := 100;                              -- No existe
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idCategoriaGasto := 1;                                -- Corregimos la categora de gasto para que no provoque error
  idParlamentario := 75;                                -- No existe
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 1;                                 -- Corregimos el parlamentario para que no provoque error
  idProveedor := 10;                                    -- No existe
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idProveedor := 1;                                     -- Corregimos el proveedor para que no provoque error
  idTipoIVA := 10;                                      -- No existe
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idTipoIVA := 1;                                       -- Corregimos el tipo de IVA para que no provoque error
  idEstado := 10;                                       -- No existe
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idEstado := 2;                                        -- Corregimos el estado para que no provoque error
  idFormaPago := 10;                                    -- No existe
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idEstado := 1;                                        -- Corregimos el estado para que no provoque error
  idFormaPago := NULL;                                  -- Corregimos la forma de pago para que no provoque error
  idParlamentario := 10;
  idParlamento := 1;
  -- El parlamentario 10 abandon el partido 1 en fecha 01/02/2013 pero sigue en el parlamento 1 sin haber sido
  -- asignado a ningn otro partido cuando se le intentar imputar un gasto
  fecha := TO_DATE ('01/03/2014', 'dd/mm/yyyy');      -- El parlamentario no tiene partido
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
  --
  idParlamentario := 9;
  idParlamento := 1;
  -- El parlamentario 9 abandon el parlamento 1 en fecha 01/02/2013 pero se le intentar imputar un gasto
  fecha := TO_DATE ('01/03/2014', 'dd/mm/yyyy');      -- El parlamentario no est en ningn parlamento
  pkg_gasto.modificacion (idGasto, fecha, idParlamento, idParlamentario, baseImponible, idTipoIVA, idCategoriaGasto, idEstado, idFormaPago, idProveedor, NULL, NULL, NULL, NULL, NULL, rsp);
  DBMS_OUTPUT.PUT_LINE ('rsp = [' || rsp || ']');
--
--
END;
/